]> arthur.barton.de Git - netdata.git/blob - plugins.d/charts.d.plugin
prevent sending microseconds on BEGIN the first time
[netdata.git] / plugins.d / charts.d.plugin
1 #!/bin/bash
2
3 PROGRAM_FILE="$0"
4 PROGRAM_NAME="$(basename $0)"
5 PROGRAM_NAME="${PROGRAM_NAME/.plugin}"
6
7 # if you need to run parallel charts.d processes
8 # just link this files with a different name
9 # in the same directory, with a .plugin suffix
10 # netdata will start multiple of them
11 # each will have a different config file
12
13 echo >&2 "$PROGRAM_NAME: started from '$PROGRAM_FILE' with options: $*"
14
15 if [ $(( ${BASH_VERSINFO[0]} )) -lt 4 ]
16 then
17         echo >&2
18         echo >&2 "$PROGRAM_NAME: ERROR"
19         echo >&2 "BASH version 4 or later is required."
20         echo >&2 "You are running version: ${BASH_VERSION}"
21         echo >&2 "Please upgrade."
22         echo >&2
23         exit 1
24 fi
25
26 # check a few commands
27 require_cmd() {
28         which "$1" >/dev/null
29         if [ $? -ne 0 ]
30                 then
31                 echo >&2 "$PROGRAM_NAME: ERROR: Command '$1' is not found in the system path."
32                 return 1
33         fi
34         return 0
35 }
36
37 require_cmd date || exit 1
38 require_cmd sed || exit 1
39 require_cmd basename || exit 1
40 require_cmd dirname || exit 1
41 require_cmd cat || exit 1
42 require_cmd grep || exit 1
43 require_cmd egrep || exit 1
44 require_cmd mktemp || exit 1
45 require_cmd awk || exit 1
46
47 # -----------------------------------------------------------------------------
48 # insternal defaults
49 # netdata exposes a few environment variables for us
50
51 pause_method="sleep" # use either "suspend" or "sleep"
52                      # DO NOT USE SUSPEND - LINUX WILL SUSPEND NETDATA TOO
53                      # THE WHOLE PROCESS GROUP - NOT JUST THE SHELL
54
55 pluginsd="${NETDATA_PLUGINS_DIR}"
56 [ -z "$pluginsd" ] && pluginsd="$( dirname $PROGRAM_FILE )"
57
58 confd="${NETDATA_CONFIG_DIR-/etc/netdata}"
59 chartsd="$pluginsd/../charts.d"
60
61 myconfig="$confd/$PROGRAM_NAME.conf"
62
63 minimum_update_frequency="${NETDATA_UPDATE_EVERY-1}"
64 update_every=${minimum_update_frequency}        # this will be overwritten by the command line
65
66 # work around for non BASH shells
67 charts_create="_create"
68 charts_update="_update"
69 charts_check="_check"
70 charts_undescore="_"
71
72 # when making iterations, charts.d can loop more frequently
73 # to prevent plugins missing iterations.
74 # this is a percentage relative to update_every to align its
75 # iterations.
76 # The minimum is 10%, the maximum 100%.
77 # So, if update_every is 1 second and time_divisor is 50,
78 # charts.d will iterate every 500ms.
79 # Charts will be called to collect data only if the time
80 # passes since the last time the collected data is equal or
81 # above their update_every.
82 time_divisor=50
83
84 # number of seconds to run without restart
85 # after this time, charts.d.plugin will exit
86 # netdata will restart it
87 restart_timeout=1800
88
89 # check if the charts.d plugins are using global variables
90 # they should not.
91 # It does not currently support BASH v4 arrays, so it is
92 # disabled
93 dryrunner=0
94
95 # check for timeout command
96 check_for_timeout=1
97
98 # the default enable/disable value for all charts
99 enable_all_charts="yes"
100
101 # -----------------------------------------------------------------------------
102 # parse parameters
103
104 debug=0
105 check=0
106 chart_only=
107 while [ ! -z "$1" ]
108 do
109         if [ "$1" = "check" ]
110         then
111                 check=1
112                 shift
113                 continue
114         fi
115
116         if [ "$1" = "debug" -o "$1" = "all" ]
117         then
118                 debug=1
119                 shift
120                 continue
121         fi
122
123         if [ -f "$chartsd/$1.chart.sh" ]
124         then
125                 debug=1
126                 chart_only="$( echo $1.chart.sh | sed "s/\.chart\.sh$//g" )"
127                 shift
128                 continue
129         fi
130
131         if [ -f "$chartsd/$1" ]
132         then
133                 debug=1
134                 chart_only="$( echo $1 | sed "s/\.chart\.sh$//g" )"
135                 shift
136                 continue
137         fi
138
139         # number check
140         n="$1"
141         x=$(( n ))
142         if [ "$x" = "$n" ]
143         then
144                 shift
145                 update_every=$x
146                 [ $update_every -lt $minimum_update_frequency ] && update_every=$minimum_update_frequency
147                 continue
148         fi
149
150         echo >&2 "Cannot understand parameter $1. Aborting."
151         echo "DISABLE"
152         exit 1
153 done
154
155
156 # -----------------------------------------------------------------------------
157 # load my configuration
158
159 if [ -f "$myconfig" ]
160         then
161         . "$myconfig"
162         if [ $? -ne 0 ]
163         then
164                 echo >&2 "$PROGRAM_NAME: cannot load $myconfig"
165                 echo "DISABLE"
166                 exit 1
167         fi
168         time_divisor=$((time_divisor))
169         [ $time_divisor -lt 10 ] && time_divisor=10
170         [ $time_divisor -gt 100 ] && time_divisor=100
171 else
172         echo >&2 "$PROGRAM_NAME: configuration file '$myconfig' not found. Using defaults."
173 fi
174
175 if [ "$pause_method" = "suspend" ]
176 then
177         # enable bash job control
178         # this is required for suspend to work
179         set -m
180 fi
181
182 # we check for the timeout command, after we load our
183 # configuration, so that the user may overwrite the
184 # timeout command we use, providing a function that
185 # can emulate the timeout command we need:
186 # > timeout SECONDS command ...
187 if [ $check_for_timeout -eq 1 ]
188         then
189         require_cmd timeout || exit 1
190 fi
191
192 # -----------------------------------------------------------------------------
193 # internal checks
194
195 # netdata passes the requested update frequency as the first argument
196 update_every=$(( update_every + 1 - 1)) # makes sure it is a number
197 test $update_every -eq 0 && update_every=1 # if it is zero, make it 1
198
199 # check the charts.d directory
200 if [ ! -d "$chartsd" ]
201         then
202         echo >&2 "$PROGRAM_NAME: cannot find charts directory '$chartsd'"
203         echo "DISABLE"
204 fi
205
206
207 # -----------------------------------------------------------------------------
208 # loop control
209
210 # default sleep function
211 LOOPSLEEPMS_HIGHRES=0
212 loopsleepms() {
213         [ "$1" = "tellwork" ] && shift
214         sleep $1
215 }
216
217 now_ms=
218 current_time_ms() {
219         now_ms="$(date +'%s')000"
220 }
221
222 # if found and included, this file overwrites loopsleepms()
223 # and current_time_ms() with a high resolution timer function
224 # for precise looping.
225 . "$pluginsd/loopsleepms.sh.inc"
226
227
228 # -----------------------------------------------------------------------------
229 # library functions
230
231 fixid() {
232         echo "$*" |\
233                 tr -c "[A-Z][a-z][0-9]" "_" |\
234                 sed -e "s|^_\+||g" -e "s|_\+$||g" -e "s|_\+|_|g" |\
235                 tr "[A-Z]" "[a-z]"
236 }
237
238
239 # -----------------------------------------------------------------------------
240 # charts check functions
241
242 all_charts() {
243         cd "$chartsd"
244         [ $? -ne 0 ] && echo >&2 "$PROGRAM_NAME: Cannot cd to $chartsd" && return 1
245
246         ls *.chart.sh | sed "s/\.chart\.sh$//g"
247 }
248
249 all_enabled_charts() {
250         local charts= enabled=
251
252         # find all enabled charts
253
254         for chart in $( all_charts )
255         do
256                 eval "enabled=\$$chart"
257                 if [ -z "${enabled}" ]
258                         then
259                         enabled="${enable_all_charts}"
260                 fi
261
262                 if [ ! "${enabled}" = "yes" ]
263                 then
264                         echo >&2 "$PROGRAM_NAME: '$chart' is NOT enabled. Add a line with $chart=yes in $myconfig to enable it (or remove the line that disables it)."
265                 else
266                         [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: '$chart' is enabled."
267                         local charts="$charts $chart"
268                 fi
269         done
270
271         local charts2=
272         for chart in $charts
273         do
274                 # check the enabled charts
275                 local check="$( cat "$chartsd/$chart.chart.sh" | sed "s/^ \+//g" | grep "^$chart$charts_check()" )"
276                 if [ -z "$check" ]
277                 then
278                         echo >&2 "$PROGRAM_NAME: chart '$chart' does not seem to have a $chart$charts_check() function. Disabling it."
279                         continue
280                 fi
281
282                 local create="$( cat "$chartsd/$chart.chart.sh" | sed "s/^ \+//g" | grep "^$chart$charts_create()" )"
283                 if [ -z "$create" ]
284                 then
285                         echo >&2 "$PROGRAM_NAME: chart '$chart' does not seem to have a $chart$charts_create() function. Disabling it."
286                         continue
287                 fi
288
289                 local update="$( cat "$chartsd/$chart.chart.sh" | sed "s/^ \+//g" | grep "^$chart$charts_update()" )"
290                 if [ -z "$update" ]
291                 then
292                         echo >&2 "$PROGRAM_NAME: chart '$chart' does not seem to have a $chart$charts_update() function. Disabling it."
293                         continue
294                 fi
295
296                 # check its config
297                 #if [ -f "$confd/$chart.conf" ]
298                 #then
299                 #       if [ ! -z "$( cat "$confd/$chart.conf" | sed "s/^ \+//g" | grep -v "^$" | grep -v "^#" | grep -v "^$chart$charts_undescore" )" ]
300                 #       then
301                 #               echo >&2 "$PROGRAM_NAME: chart's $chart config $confd/$chart.conf should only have lines starting with $chart$charts_undescore . Disabling it."
302                 #               continue
303                 #       fi
304                 #fi
305
306                 #if [ $dryrunner -eq 1 ]
307                 #       then
308                 #       "$pluginsd/charts.d.dryrun-helper.sh" "$chart" "$chartsd/$chart.chart.sh" "$confd/$chart.conf" >/dev/null
309                 #       if [ $? -ne 0 ]
310                 #       then
311                 #               echo >&2 "$PROGRAM_NAME: chart's $chart did not pass the dry run check. This means it uses global variables not starting with $chart. Disabling it."
312                 #               continue
313                 #       fi
314                 #fi
315
316                 local charts2="$charts2 $chart"
317         done
318
319         echo $charts2
320         [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: enabled charts: $charts2"
321 }
322
323
324 # -----------------------------------------------------------------------------
325 # load the charts
326
327 suffix_update_every="_update_every"
328 active_charts=
329 for chart in $( all_enabled_charts )
330 do
331         [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: loading chart: '$chartsd/$chart.chart.sh'"
332         . "$chartsd/$chart.chart.sh"
333
334         if [ -f "$confd/$chart.conf" ]
335         then
336                 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: loading chart options: '$confd/$chart.conf'"
337                 . "$confd/$chart.conf"
338         else
339                 echo >&2 "$PROGRAM_NAME: $chart: configuration file '$confd/$chart.conf' not found. Using defaults."
340         fi
341
342         eval "dt=\$$chart$suffix_update_every"
343         dt=$(( dt + 1 - 1 )) # make sure it is a number
344         if [ $dt -lt $update_every ]
345         then
346                 eval "$chart$suffix_update_every=$update_every"
347         fi
348
349         $chart$charts_check
350         if [ $? -eq 0 ]
351         then
352                 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: '$chart' activated"
353                 active_charts="$active_charts $chart"
354         else
355                 echo >&2 "$PROGRAM_NAME: chart '$chart' check() function reports failure."
356         fi
357 done
358 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: activated charts: $active_charts"
359
360
361 # -----------------------------------------------------------------------------
362 # check overwrites
363
364 # enable work time reporting
365 debug_time=
366 test $debug -eq 1 && debug_time=tellwork
367
368 # if we only need a specific chart, remove all the others
369 if [ ! -z "${chart_only}" ]
370 then
371         [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: requested to run only for: '${chart_only}'"
372         check_charts=
373         for chart in $active_charts
374         do
375                 if [ "$chart" = "$chart_only" ]
376                 then
377                         check_charts="$chart"
378                         break
379                 fi
380         done
381         active_charts="$check_charts"
382 fi
383 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: activated charts: $active_charts"
384
385 # stop if we just need a pre-check
386 if [ $check -eq 1 ]
387 then
388         echo >&2 "CHECK RESULT"
389         echo >&2 "Will run the charts: $active_charts"
390         exit 0
391 fi
392
393 # -----------------------------------------------------------------------------
394 # create temp dir
395
396 TMP_DIR=
397 chartsd_cleanup() {
398         cd /tmp
399         if [ ! -z "$TMP_DIR" -a -d "$TMP_DIR" ]
400         then
401                 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: cleaning up temporary directory $TMP_DIR ..."
402                 rm -rf "$TMP_DIR"
403         fi
404         exit 0
405 }
406 trap chartsd_cleanup EXIT
407 trap chartsd_cleanup SIGHUP
408 trap chartsd_cleanup INT
409
410 if [ $UID = "0" ]
411 then
412         TMP_DIR="$( mktemp -d /var/run/netdata-${PROGRAM_NAME}-XXXXXXXXXX )"
413 else
414         TMP_DIR="$( mktemp -d /tmp/.netdata-${PROGRAM_NAME}-XXXXXXXXXX )"
415 fi
416
417 cd "$TMP_DIR" || exit 1
418
419 # -----------------------------------------------------------------------------
420 # create charts
421
422 run_charts=
423 for chart in $active_charts
424 do
425         [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: Calling '$chart$charts_create()'..."
426         $chart$charts_create
427         if [ $? -eq 0 ]
428         then
429                 run_charts="$run_charts $chart"
430                 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: '$chart' has initialized."
431         else
432                 echo >&2 "$PROGRAM_NAME: chart '$chart' function '$chart$charts_create()' reports failure."
433         fi
434 done
435 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: run_charts='$run_charts'"
436
437
438 # -----------------------------------------------------------------------------
439 # update dimensions
440
441 if [ -z "$run_charts" ]
442         then
443         echo >&2 "$PROGRAM_NAME: No charts to collect data from."
444         echo "DISABLE"
445         exit 1
446 fi
447
448 declare -A charts_last_update=() charts_update_every=() charts_next_update=() chart_run_counter=()
449 global_update() {
450         local exit_at \
451                 c=0 dt ret exec_start_ms exec_end_ms \
452                 chart now_charts=() next_charts=($run_charts)
453
454         # return the current time in ms in $now_ms
455         current_time_ms
456
457         exit_at=$(( now_ms + (restart_timeout * 1000) ))
458
459         for chart in $run_charts
460         do
461                 eval "charts_update_every[$chart]=\$$chart$suffix_update_every"
462                 test -z "${charts_update_every[$chart]}" && charts_update_every[$charts]=$update_every
463                 charts_last_update[$chart]=$((now_ms - (now_ms % (charts_update_every[$chart] * 1000) ) ))
464                 charts_next_update[$chart]=$(( charts_last_update[$chart] + (charts_update_every[$chart] * 1000) ))
465                 charts_run_counter[$chart]=0
466
467                 echo "CHART netdata.plugin_$chart '' 'Execution time for $chart plugin' 'milliseconds / run' netdata netdata area 90000 ${charts_update_every[$chart]}"
468                 echo "DIMENSION run_time 'run time' absolute 1 1"
469         done
470
471         # the main loop
472         while [ 1 ]
473         do
474                 c=$((c + 1))
475                 now_charts=("${next_charts[@]}")
476                 next_charts=()
477
478                 # return the current time in ms in $now_ms
479                 current_time_ms
480
481                 for chart in "${now_charts[@]}"
482                 do
483                         # echo >&2 "DEBUG: chart: $chart last: ${charts_last_update[$chart]}, next: ${charts_next_update[$chart]}, now: ${now_ms}"
484                         if [ ${now_ms} -ge ${charts_next_update[$chart]} ]
485                         then
486                                 dt=$(( (now_ms - charts_last_update[$chart]) ))
487                                 #echo >&2 "DEBUG: chart: $chart last: ${charts_last_update[$chart]}, next: ${charts_next_update[$chart]}, now: ${now_ms}, dt: ${dt}"
488
489                                 charts_last_update[$chart]=$now_ms
490
491                                 while [ ${charts_next_update[$chart]} -lt ${now_ms} ]
492                                 do
493                                         charts_next_update[$chart]=$(( charts_next_update[$chart] + (charts_update_every[$chart] * 1000) ))
494                                 done
495
496                                 # the first call should not give a duration
497                                 # so that netdata calibrates to current time
498                                 charts_run_counter[$chart]=$(( charts_run_counter[$chart] + 1 ))
499                                 dt=$(( dt * 1000 ))
500                                 test ${charts_run_counter[$chart]} -eq 1 && dt=
501
502                                 exec_start_ms=$now_ms
503                                 $chart$charts_update $dt
504                                 ret=$?
505                                 
506                                 # return the current time in ms in $now_ms
507                                 current_time_ms; exec_end_ms=$now_ms
508
509                                 echo "BEGIN netdata.plugin_$chart $dt"
510                                 if [ $ret -eq 0 ]
511                                 then
512                                         echo "SET run_time = $(( exec_end_ms - exec_start_ms ))"
513                                         next_charts+=($chart)
514                                 else
515                                         echo "SET run_time = $(( (exec_end_ms - exec_start_ms) * -1 ))"
516                                         echo >&2 "$PROGRAM_NAME: chart '$chart' update() function reports failure. Disabling it."
517                                 fi
518                                 echo "END"
519                         else
520                                 next_charts+=($chart)
521                         fi
522                 done
523
524                 if [ "$pause_method" = "suspend" ]
525                 then
526                         echo "STOPPING_WAKE_ME_UP_PLEASE"
527                         suspend || ( echo >&2 "$PROGRAM_NAME: suspend returned error $?, falling back to sleep."; loopsleepms $debug_time $update_every $time_divisor)
528                 else
529                         # wait the time you are required to
530                         #loopsleepms $debug_time $update_every $time_divisor
531                         if [ ${LOOPSLEEPMS_HIGHRES} -eq 1 ]
532                                 then
533                                 sleep 0.2
534                         else
535                                 sleep 1
536                         fi
537                 fi
538
539                 test ${now_ms} -ge ${exit_at} && exit 0
540         done
541 }
542
543 global_update